#lesson.2.r
#function list: ifelse, scan, matrix, table, sample, round

#ifelse = a binary classification function
t <- 1:20
t
T <- 20:1
T
ifelse(t<12,0,1)
ifelse(t<5 | t>15,0,1) 
ifelse(t^2 <25,0,1)
ifelse(t<5,0,t)
ifelse(T<t,0,1)
ifelse(T/t <0.5 | T/t > 4,0,1)

#count T-value greater than 12
sum(ifelse(T>12,1,0))



#two dimensional array  #matrix(observations, rows, columns)
data <- matrix(1:16,4)
data

#subscript
data[2,2]
data[,2]  #column two
data[2,]  #row two
data[,-2]  #column two eliminated
data[-2,]  #row two eliminated

data[1:2,3:4]  #rows 1 and 2 and columns 3 and 4 are selected
data[2,]/data[1,]

#scan reads input values from a file
#scan("~/values.in/data.save",sep=",",fill=TRUE,skip=1)
#scan(<file>,sep=",")
#fill -- input from keyboard
#skip = k skips the first k lines in a file
#plus others see $scan for details

#matrix
temp <- c(1,5,9,2,6,10,3,7,11,4,8,12)
matrix(temp,3,4)
matrix(temp,3)
matrix(temp,3,byrow=TRUE)
matrix(temp,3,byrow=FALSE) #default

#transpose of matrix t
t(matrix(temp,3,4)) 

x <- 1:18
matrix(x,6,3)
matrix(x,3,6)
t(matrix(x,6,3))
#labels rows/columns
matrix(x,6,3,dimnames=list(c("a","b","c","d","e","f"),c("I","II","III")))

#table  #R-functions equally apply to table and matrix 
d <- rep(1:5,5:1)
table(d)

data <- c(10,6,4,7,4,1,2,5,6,7,5,9,1,9,7,4,2,6,1,5,4,2,7,6,9,7,6,3,8,9,9,0,7,4,0,7,7,5,3,2,9,7,6,3,8,9,9,0,7,4,0,7,7,5,3,2)
tab <- table(data)
tab

#two-way table
x <- rep(1:3,5:3)
x
y <- rep(0:1,6)
y
table(y,x)
table(x,y)
tab <- table(x,y)
tab[2,2]
tab[,2]  #second column
tab[2,]  #second row
sum(tab)
tab/2
10*tab
log(tab)
sqrt(tab)

#R-literals
8+2
5-2
4*12
2^10
2**10

#R-algebra
a <- 3
b <- 4
a+b
a*b
a-b
a/b
(a+b)^2
(a/b)^(b/a)
c <- 10
a/b*c
a/(b*c)

#approximate normal distribution probabilities
x <- seq(0,2,.2)
P <- (1+sqrt(1-exp(-2*x^2/pi)))/2
round(P,3)

#sample -- random sample of data with or without replacement

#sample(data,sample size,method)
#data
d <- 1:20
sample(d,10,replace=TRUE)   #duplicates are possible
sample(d,10,replace=FALSE)  #no duplicates are possible

#create a random binary variable
s <- sample(c(0,1),100,replace=TRUE)
table(s)

#four random permutations
test <- 1:10
sample(test,length(test),replace=FALSE)
sample(test,length(test),replace=FALSE)
sample(test,length(test),replace=FALSE)
sample(test,length(test),replace=FALSE)

#round -- rounds values to a specific number of digits
#round(value,digits)
pi <- 3.141593
cbind(round(pi,0),round(pi,1),round(pi,2),round(pi,3),round(pi,4))


