#lesson.3.r
#probability distribution root symbols: norm, chisq, f, t, binom, poiss
#type of probability distribution: density(d), quantile(q), cumulative probably(p),random (r)
#Values are created by combing the root symbol and the letter for the desired property 

#example: normal probability distribution
m <- 10 #mean value (default = 0) 
s <- 2  #standard deviations (default = 1) 
round(dnorm(8:12,m,s),3) #height of the normal probability distribution 
round(qnorm(c(0.025,0.25,0.5,0.75,0.975),m,s),3) #quantile values
round(pnorm(8:12,m,s),3) #cumulative probabilities
n <- 10 #sample size
round(rnorm(n,m,s),3)  #random values

#example:  chi-square probability distribution
df <- 2  #degrees of freedom
round(pchisq(c(0.5,1.0,1.5,2,2.5,3),df),3)

#example:  uniform probability distribution
n <- 10 #sample size
a <- 0  #lower bound
b <- 1  #upper bound
round(runif(n,a,b),3)

#example:  binomial probability distribution
n <- 6
p <- 0.5
dbinom(0:6,n,p)
pbinom(0:6,n,p)
rbinom(10,n,p)

#random 2000 coin tosses
coin <- rbinom(2000,1,0.5)
coin[1:20]
mean(coin)
var(coin)

#example:  Poisson probability distribution
m <- 2  #Poisson parameter
round(ppois(0:6,m),3)
n <- 10000
x <- rpois(n,m)
mean(x)
var(x)

